package com.elmakers.mine.craftbukkit.persistence.data;

import java.util.logging.Logger;

import com.elmakers.mine.craftbukkit.persistence.Persistence;

/**
 * Represents a single field in a data row.
 * 
 * @author NathanWolf
 *
 */
public class DataField
{
	public DataField()
	{	
	}
	
	public DataField(Object value)
	{	
		this.value = value;
	}
	
	public DataField(String name, DataType type)
	{
		this.name = name;
		this.type = type;
	}
	
	public DataField(String name, DataType type, Object value)
	{
		this.name = name;
		this.type = type;
		this.value = value;
	}
	
	public void setType(DataType type)
	{
		this.type = type;
	}

	public DataType getType()
	{
		return type;
	}
	
	public void setValue(Object value)
	{
		this.value = value;
		if (type == null)
		{
			type = DataType.getTypeFromClass(value.getClass());
		}
	}
	
	public Object getValue()
	{
		return value;
	}
	
	public Object getValue(Class<?> targetClass)
	{
		return DataType.convertValue(value, targetClass);
	}
	
	public void setName(String name)
	{
		this.name = name;
	}

	public String getName()
	{
		return name;
	}

	public void setAutogenerated(boolean autogenerate)
	{
		this.autogenerate = autogenerate;
	}
	
	public boolean isAutogenerated()
	{
		return autogenerate;
	}

	public void setIdField(boolean id)
	{
		idField = id;
	}
	public boolean isIdField()
	{
		return idField;
	}

	protected static Logger log = Persistence.getLogger();
	protected DataType 		type;
	protected Object		value;
	protected String		name;
	protected boolean		autogenerate;
	protected boolean		idField;
}
